#------------------------------------------------------------------------------
# <auto-generated>
#     This file was auto generated.
#
#     Changes to this file may cause incorrect behavior and will be lost if
#     the code is regenerated.
# </auto-generated>
#------------------------------------------------------------------------------
import typing
from abc import abstractmethod, ABCMeta
from Oasys.AdSec.Materials.StressStrainCurves import ITensionCompressionCurve
from UnitsNet import Pressure


# noinspection PyPep8Naming
class IMaterial(metaclass=ABCMeta):
    """A base class for all material types.
    
    See "~/articles/glossary.md#materialmaterial""Glossary/see
    """

    @property
    def Serviceability(self) -> ITensionCompressionCurve:
        """The material's stress-strain relationship for serviceability (SLS) analysis.
        """
        pass

    @property
    def Strength(self) -> ITensionCompressionCurve:
        """The material's stress-strain relationship for strength (ULS) analysis.
        """
        pass


# noinspection PyPep8Naming
class IConcreteCrackCalculationParameters(metaclass=ABCMeta):
    """The material parameters used in crack calculations to the current design code.
    In some instances these may be different to the material's stress-strain curves.
    """

    @property
    def CharacteristicTensileStrength(self) -> Pressure:
        """Characteristic tensile strength.
        """
        pass

    @property
    def CharacteristicCompressiveStrength(self) -> Pressure:
        """Characteristic compressive strength.
        """
        pass

    @property
    def ElasticModulus(self) -> Pressure:
        """Elastic modulus.
        """
        pass

    @staticmethod
    def Create(elasticModulus: Pressure, characteristicCompressiveStrength: Pressure, characteristicTensileStrength: Pressure) -> IConcreteCrackCalculationParameters:
        """Creates a new "IConcreteCrackCalculationParameters" from
        "Property ElasticModulus",
        "Property CharacteristicCompressiveStrength" and
        "Property CharacteristicTensileStrength".
        <param name="elasticModulus">Elastic modulus.</param><param name="characteristicCompressiveStrength">Characteristic compressive strength.</param><param name="characteristicTensileStrength">Characteristic tensile strength.</param>
        """
        pass


# noinspection PyPep8Naming
class IConcrete(IMaterial, metaclass=ABCMeta):
    """A concrete material, defined by its stress-strain relationships for both strength and serviceability analysis.
    
    For pre-defined standard concrete materials, see "None StandardMaterials"
    """

    @property
    def ConcreteCrackCalculationParameters(self) -> IConcreteCrackCalculationParameters:
        """The material parameters used in crack calculations.
        """
        pass

    @staticmethod
    @typing.overload
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve, concreteCrackCalculationParameters: IConcreteCrackCalculationParameters) -> IConcrete:
        """Creates a new concrete material from its strength (ULS),
        serviceability (SLS) stress-strain relationship and
        material parameters required for crack calculations.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :param concreteCrackCalculationParameters: The material parameters required for crack calculations.
        :type concreteCrackCalculationParameters: IConcreteCrackCalculationParameters
        :return: A new concrete material with the given sterss-strain relationships.
        :rtype: IConcrete
        """
        pass

    @staticmethod
    @typing.overload
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve) -> IConcrete:
        """Creates a new concrete material from its strength (ULS) and
        serviceability (SLS) stress-strain relationship.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :return: A new concrete material with the given sterss-strain relationships.
        :rtype: IConcrete
        """
        pass


# noinspection PyPep8Naming
class IFrp(IMaterial, metaclass=ABCMeta):
    """A fibre-reinforced polymer (FRP) material, defined by its stress-strain relationships for both strength and serviceability analysis.
    
    For pre-defined standard FRP materials, see "None StandardMaterials"
    """

    @staticmethod
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve) -> IFrp:
        """Creates a new FRP material from its strength (ULS) and
        serviceability (SLS) stress-strain relationship.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :return: A new FRP material with the given sterss-strain relationships.
        :rtype: IFrp
        """
        pass


# noinspection PyPep8Naming
class IReinforcement(IMaterial, metaclass=ABCMeta):
    """A reinforcement material, defined by its stress-strain relationships for both strength and serviceability analysis.
    
    For pre-defined standard reinforcement materials, see "None StandardMaterials"
    """

    @staticmethod
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve) -> IReinforcement:
        """Creates a new reinforcement material from its strength (ULS) and
        serviceability (SLS) stress-strain relationship.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :return: A new reinforcement material with the given sterss-strain relationships.
        :rtype: IReinforcement
        """
        pass


# noinspection PyPep8Naming
class ISteel(IMaterial, metaclass=ABCMeta):
    """A steel material, defined by its stress-strain relationships for both strength and serviceability analysis.
    
    For pre-defined standard steel materials, see "None StandardMaterials"
    """

    @staticmethod
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve) -> ISteel:
        """Creates a new steel material from its strength (ULS) and
        serviceability (SLS) stress-strain relationship.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :return: A new steel material with the given sterss-strain relationships.
        :rtype: ISteel
        """
        pass
