#------------------------------------------------------------------------------
# <auto-generated>
#     This file was auto generated.
#
#     Changes to this file may cause incorrect behavior and will be lost if
#     the code is regenerated.
# </auto-generated>
#------------------------------------------------------------------------------
import typing
from abc import abstractmethod, ABCMeta
from Oasys.AdSec.Materials import IReinforcement
from UnitsNet import Length


# noinspection PyPep8Naming
class IBarBundle(metaclass=ABCMeta):
    """A bar bundle is defined by bar diameter, material and number of bars in the bundle.
    It can have one to four reinforcement bars.
    
    See "~/articles/glossary.md#bar-bundlebar-bundle""Glossary/see
    """

    @property
    def CountPerBundle(self) -> int:
        """The number of reinforcement bars per bundle.
        """
        pass

    @CountPerBundle.setter
    def CountPerBundle(self, value: int) -> None: ...

    @property
    def Diameter(self) -> Length:
        """The diameter of reinforcement bar.
        """
        pass

    @Diameter.setter
    def Diameter(self, value: Length) -> None: ...

    @property
    def Material(self) -> IReinforcement:
        """The material of reinforcement bar.
        """
        pass

    @Material.setter
    def Material(self, value: IReinforcement) -> None: ...

    @staticmethod
    @typing.overload
    def Create(material: IReinforcement, diameter: Length, countPerBundle: int) -> IBarBundle:
        """Creates a new multi-bar "IBarBundle" from a material,
        diameter of each bar and the number of bars in the bundle.

        :param material: Defines the reinforcement bar's material.
        :type material: IReinforcement
        :param diameter: Defines the reinforcement bar's diameter.
        :type diameter: Length
        :param countPerBundle: Defines the number of bars in the bundle.
        :type countPerBundle: int
        """
        pass

    @staticmethod
    @typing.overload
    def Create(material: IReinforcement, diameter: Length) -> IBarBundle:
        """Creates a new single-bar "IBarBundle" from a material and diameter.

        :param material: Defines the reinforcement bar's material.
        :type material: IReinforcement
        :param diameter: Defines the reinforcement bar's diameter.
        :type diameter: Length
        """
        pass
