#------------------------------------------------------------------------------
# <auto-generated>
#     This file was auto generated.
#
#     Changes to this file may cause incorrect behavior and will be lost if
#     the code is regenerated.
# </auto-generated>
#------------------------------------------------------------------------------
import typing
from abc import abstractmethod, ABCMeta
from System import Array, ValueType
from UnitsNet import Pressure
from UnitsNet.CustomCode.Units import PressureReference


# noinspection PyPep8Naming
class ReferencePressure(ValueType):
    """Pressure tied to a real-world reference, allowing conversion between references.
    <list type="bullet"><item><description>Absolute is referenced to true vacuum.</description></item><item><description>Gauge references the local atmospheric pressure.</description></item><item><description>Vacuum is the negative of the gauge.</description></item></list>
    """

    BaseReference: PressureReference
    """The base reference representation of "ReferencePressure" for the numeric value stored internally. All
    conversions go via this value.
    """

    @property
    def AtmosphericPressure(self) -> Pressure:
        """Represents the pressure at which _pressure is referenced (1 atm default)
        """
        pass

    @AtmosphericPressure.setter
    def AtmosphericPressure(self, value: Pressure) -> None: ...

    References: typing.ClassVar[Array[PressureReference]]

    @property
    def Reference(self) -> PressureReference:
        """Gets the "PressureReference" of the "ReferencePressure"
        """
        pass

    @property
    def Pressure(self) -> Pressure:
        """The "Property Pressure" at the given "PressureReference".
        """
        pass

    @property
    def Gauge(self) -> Pressure:
        """Get Gauge "Pressure".
        It references pressure level above Atmospheric pressure.
        """
        pass

    @property
    def Absolute(self) -> Pressure:
        """Get Absolute "Pressure".
        It is zero-referenced pressure to the perfect vacuum.
        """
        pass

    @property
    def Vacuum(self) -> Pressure:
        """Get Vacuum "Pressure".
        It is a negative Gauge pressure when Absolute pressure is below Atmospheric pressure.
        """
        pass

    def __init__(self, pressure: Pressure) -> None:
        """Initializes a new instance of the "ReferencePressure" struct requiring measured
        "Pressure"
        parameter. Assumes the "PressureReference" to "Field Absolute", with 1 atm as
        the atmospheric "Pressure".

        :param pressure: The measured absolute
        :type pressure: Pressure
        """
        pass

    def __init__(self, pressure: Pressure, reference: PressureReference) -> None:
        """Initializes a new instance of the "ReferencePressure" struct requiring
        measured "Pressure" and "PressureReference" parameters. Assumes 1 atm as the atmospheric
        "Pressure".

        :param pressure: The measured
        :type pressure: Pressure
        :param reference: 
                The referenced  for the measured
        :type reference: PressureReference
        """
        pass

    def __init__(self, pressure: Pressure, reference: PressureReference, atmosphericPressure: Pressure) -> None:
        """Initializes a new instance of the "ReferencePressure" struct requiring
        measured "Pressure", "PressureReference", and atmospheric "Pressure"
        parameters

        :param pressure: The measured
        :type pressure: Pressure
        :param reference: 
                The referenced  for the measured
        :type reference: PressureReference
        :param atmosphericPressure: The atmospheric  where the measurement was taken.
        :type atmosphericPressure: Pressure
        """
        pass
